package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.model.AnswerEntity;
import com.rf.psychological.dao.model.DimensionEntity;
import com.rf.psychological.scale.dao.model.ScaleMarksEntity;

import java.text.DecimalFormat;
import java.util.*;

/**
 * @author lhh
 * @description:危险驾驶行为量表
 * @date 2021/11/04 15:55
 */

public class DDBSScale extends BaseScale {
    public DDBSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }
    public JSONObject scaleCalculate() throws Exception{

        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String,String>> resultMapList = new ArrayList<>();
        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        Map<String,Double> dimensionScoreMap = new HashMap<>();
        if (dimensionEntities.size() > 0){
            //计算每个维度得分

            double[] dimensionScore = new double[dimensionEntities.size()];
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject1 = jsonArray.getJSONObject(i);

                for (int y = 0; y < dimensionEntities.size(); y++) {

                    DimensionEntity dimensionEntity = dimensionEntities.get(y);
                    String questionNos = dimensionEntity.getQuestionNo();
                    String[] questionNo = questionNos.split("；");
                    for (String question:questionNo){
                        if (question.equals(jsonObject1.getString("questionNo"))){
                            for (AnswerEntity answerEntity:answerEntities){
                                ///只用比较选项内容，进而判定该题目的分数值
                                if (answerEntity.getQuestionNo().equals(question) &&answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                                    dimensionScore[y] += Double.parseDouble(answerEntity.getScore());
                                }
                            }
                            break;
                        }
                    }
                }

            }
            //计算每个维度的平均分
            DecimalFormat df = new DecimalFormat("######0.00");
            double[] Mdscore = new double[dimensionScore.length];
            Mdscore[0]= Double.parseDouble(df.format(dimensionScore[0]/14.0));
            Mdscore[1]= Double.parseDouble(df.format(dimensionScore[1]/14.0));


            resultMap0.put("危险驾驶行为自我报告量表均分", String.valueOf(Mdscore[0]));
            resultMap0.put("危险驾驶行为自我评估量表均分", String.valueOf(Mdscore[1]));

            resultMap0.put("均分解释：", "量表得分为该量表下所有题目的平均值RD-SR \n得分越高，代表驾驶员的危险驾驶行为越多； \nRD-SA得分越高，代表驾驶员卷入危险驾驶情境的可能性越大。");

            resultJson.put("驾驶超速维度均分", String.valueOf(Mdscore[0]));
            resultJson.put("违反交通规则维度均分", String.valueOf(Mdscore[1]));
            dimensionScoreMap.put("2c91f37d7bec0878017c43e53f624878",Mdscore[0]);
            dimensionScoreMap.put("2c91f37d7bec0878017c43e53f964879",Mdscore[1]);
            resultJson.put("dimensionScoreMap",dimensionScoreMap);
            resultJson.put("均分解释：", "量表得分为该量表下所有题目的平均值RD-SR \n得分越高，代表驾驶员的危险驾驶行为越多； \nRD-SA得分越高，代表驾驶员卷入危险驾驶情境的可能性越大。");


            resultMapList.add(resultMap0);
            resultJson.put("dimensionScoreMap",dimensionScoreMap);
        }

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",resultJson.getString("scaleName"));
        returnJson.put("resultJson",resultJson);

        return returnJson;

    }


}
